// Duck - Sniping Practice for Tribes 2 by James C. Vetsch aka Hak|Hakuryu
//
// http://www.PlanetTribes.com/Balance 
//
// This is basically a test, and many things will change in future versions
// Probably will not do any more training based, but have all missions under the UTTC idea ( another gametype ) 
// host'able like a regular game server
//
// I give help on any coding, but please make sure you send CLEAR examples of your question or problem.
//
// Any training type maps/gametypes you make, please let me know and I'll review and add links to your site from mine
// or just offer it at my site if you do not have one.

// ****************************************************************************ADD LIST

// test
// hard, lower bot scriptkill time, because of lower arcs... they are on the ground alive sometimes

// ****************************************************************************

// don't want this executing when building graphs
if($OFFLINE_NAV_BUILD)
   return;

//moveMap.bindCmd( keyboard, "z", "pullTest();","" ); // for testing remove
activatePackage(Duck);

// mission variables

$PullAmount = 40; // Number of pulls that make up a single training instance
$MinPullCount = 2; // min amount of ducks per pull
$MaxPullCount = 4; // MUST HAVE AT LEAST THIS NUMBER OF DUCK SPAWN MARKERS IN THE MAP!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$KillMin[1] = 15; // difficulty pass 
$KillMin[2] = 25;
$KillMin[3] = 35;
$voice = "Derm"@getRandom(1,3);
$voicePitch = 1 - ((getRandom(20) - 10)/100);

$PlayerSpawnGroup = "MissionGroup/Teams/Team1/spawnMarkers";
$DuckSpawnGroup = "MissionGroup/Teams/Team2/spawnMarkers";
$PlayerDefaultSpawn = "-496.58 -3.649 162.256 0 0 1 1.46"; 	// setupSpawns() doesnt run until after 1st player spawn, so
	// this spawn point is used for first spawn. I layed the spawn 'camera' and got it's transform for this number

$ItemPopTime = 1000; // make dropped items disappear after only 1 second
$CorpseTimeoutValue = 1000; // make bot corpse's disappear after 1 second

// I wanted to do $Duck[0].position and so on, but it won't work for some reason... wtf? Other code is done that way... ?
// 0 - position - set in spawnSetup
// 1 - base zVelocity - added to for difficulty
// 2 - velocity scale
// 3 - x and y Velocity scale
// 4 - name
// higher than 300 (2) and 300 (3) together causes stuttering with the graphics
// can be seen sometimes at lower settings also.. check this
$Duck[0,1] = 10; // increase for higher arcs
$Duck[0,2] = 300; // increase for faster arcs
$Duck[0,3] = 300; // increase for faster movement, only works in small increments
$Duck[0,4] = "Hak|Hakuryu";
$Duck[1,1] = 12;
$Duck[1,2] = 300; // 400
$Duck[1,3] = 300;
$Duck[1,4] = "Hak|Genpachi";
$Duck[2,1] = 14;
$Duck[2,2] = 300;
$Duck[2,3] = 50;
$Duck[2,4] = "Hak|Nurikabe";
$Duck[3,1] = 12;
$Duck[3,2] = 300;
$Duck[3,3] = 300;
$Duck[3,4] = "Hak|Fujin";
$Duck[4,1] = 10;
$Duck[4,2] = 300; // 400
$Duck[4,3] = 100;
$Duck[4,4] = "Hak|Raijin";
$Duck[5,1] = 10;
$Duck[5,2] = 300; // 400
$Duck[5,3] = 400;
$Duck[5,4] = "Hak|Soudou";
$Duck[6,1] = 10;
$Duck[6,2] = 300;
$Duck[6,3] = 300;
$Duck[6,4] = "Hak|Oishi";
$Duck[7,1] = 10;
$Duck[7,2] = 300; // 350
$Duck[7,3] = 300;
$Duck[7,4] = "Hak|Tessai";
$Duck[8,1] = 24;
$Duck[8,2] = 300; // 400
$Duck[8,3] = 400;
$Duck[8,4] = "Hak|Aiken";
$Duck[9,1] = 10;
$Duck[9,2] = 300;
$Duck[9,3] = 300;
$Duck[9,4] = "Sierra Sucks!";
$Duck[10,1] = 10;
$Duck[10,2] = 300; // 400
$Duck[10,3] = 300;
$Duck[10,4] = "Null Space";
$Duck[11,1] = 10;
$Duck[11,2] = 300;
$Duck[11,3] = 400;
$Duck[11,4] = "Hakkenden!";
$Duck[12,1] = 10;
$Duck[12,2] = 300;
$Duck[12,3] = 300;
$Duck[12,4] = "DJ Spyda";
$Duck[13,1] = 14;
$Duck[13,2] = 300;
$Duck[13,3] = 300;
$Duck[13,4] = "{=MaS=}Qa.Man.9";
$Duck[14,1] = 10;
$Duck[14,2] = 300; // 400
$Duck[14,3] = 300;
$Duck[14,4] = "31073|RT";

$num = 0; // temp for testing

function singlePlayerGame::deactivatePackages(%game) {
	// DO I NEED THIS?
	// if so, and multiple missions, will need a general cleanup
	// and, if other people make training missions, this makes using 'SinglePlayer' as the mission type
	// for added missions not a viable answer
	//error("singlePlayerGame packages deactivated");
	//Deactivate packages...gotta catch'm all
	//deactivatepackage(SinglePlayer);
	deactivatepackage(Training1);
	deactivatepackage(Training2);
	deactivatepackage(Training3);
	deactivatepackage(Training4);
	deactivatepackage(Training5);
	deactivatepackage(Training6);
	deactivatepackage(Duck);
	deactivatePackage(singlePlayerMissionAreaEnforce);
}

//Duck package =======================================================

package Duck {

	function startCurrentMission(%game) {
		AISystemEnabled(false);   // bot will look toward center of world (0,0,0) upon spawn if you dont do this...
		// EVEN if you transform the bot after spawning it.
		// took me only 6 or so hours to figure this out... AAARRRRGGGHHHH!
		setupSpawns();
		setUpDifficultySettings($pref::trainingDifficulty);

	}

	function setupSpawns() {
		%group = nameToID($PlayerSpawnGroup);
   		if (%group != -1) {
      		$PlayerSpawnCount = %group.getCount();
      		if ($PlayerSpawnCount != 0) {
      			for(%i=0;%i<$PlayerSpawnCount ;%i++) {
					%obj = %group.getObject(%i);
					$PlayerSpawn[%i] = %obj.getTransform();
				}
			}
      		else
      			error("No spawn point markers found within group");
      	}
		else
			error("No spawn point group found");
		%group = nameToID($DuckSpawnGroup);
   		if (%group != -1) {
      		$DuckSpawnCount = %group.getCount(); // MUST BE AT LEAST $MaxPullCount
      		if ($DuckSpawnCount != 0) {
			
      			for(%i=0;%i<$DuckSpawnCount ;%i++) {
					%obj = %group.getObject(%i);
					$Duck[%i,0] = %obj.getTransform();
					echo("duck pos - " @ $Duck[%i,0]);				
				}
			}
      		else
      			error("No spawn point markers found within group");
      	}
		else
			error("No spawn point group found");
	}

	function SinglePlayerGame::equip(%game, %player, %set) {
		if(!isObject(%player))
			return;
		%player.clearInventory();
		if(!%set)
			%set = %player.client.equipment;
		for(%i =0; %i<$InventoryHudCount; %i++)
			%player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);
		%player.setArmor("Light");
		%player.setInventory(energypack, 1);
		%player.setInventory(RepairKit, 1);
		%player.setInventory(SniperRifle, 1);
		%player.use("SniperRifle");
		%player.weaponCount = 1;
	}

	function SinglePlayerGame::spawnPlayer( %game, %client, %respawn ) {
		%spawnPoint = %game.pickPlayerSpawn( %client, %respawn );
   		%game.createPlayer( %client, %spawnPoint, %respawn );
		if(!%client.spawnFlag && !%client.isAIControlled()) {
			%client.spawnFlag = 1;
			centerPrintAll("Hit the switch in the tower to start the mission.",8,1);
		}
	}

	function SinglePlayerGame::pickPlayerSpawn(%game, %client, %respawn)
	{
		// bypasses game.pickTeamSpawn
		%respawn = false;
		if(%client.isAIcontrolled()) {
			return $Duck[$Pull[$num],0];
		}
		else {
			%pos = mFloor(getRandom() * $PlayerSpawnCount);
			if($PlayerSpawn[%pos] $= "")  {
				return $PlayerDefaultSpawn;
			}
			else
				return $PlayerSpawn[%pos];
		}
	}

	function Pull() {
		if($PullAmount) {
			setupPull();
			for(%i=1;%i<=$PullCount;%i++) {
				$num = %i; // pickPlayerSpawn will choose its own spot, this overrides
				%client = AIConnect($Duck[$Pull[%i],4], 2, 0.45, true, $voice, $voicePitch);
				%player = %client.player;
				%vector = %player.getForwardVector();
				%vector = getWords(%vector,0,1);
				%vector = vectorScale(%vector,$Duck[$Pull[%i],3]);
				%vector = getWords(%vector,0,1) @ " " @ $Duck[$Pull[%i],1];
				%player.applyImpulse($Duck[$Pull[%i],0],vectorScale(%vector,$Duck[$Pull[%i],2]));
				%player.schedule($TimeBetweenPulls - 1000,"scriptKill",0);
			}
			$PullAmount -= 1;
			schedule($TimeBetweenPulls,0,"Pull");
		}
		else // all pulls done
			scoreEnd();	
	}
		
	function setupPull() {
		// setup all bot starts
		// get number of ducks
		$PullCount = mFloor(getRandom() * $MaxPullCount) + 1;
		if($PullCount < $MinPullCount)
			$PullCount = $MinPullCount;
		// error test
		if($PullCount > $DuckSpawnCount) {
			// error map
		}
		// choose starting positions
		for(%i = 1; %i <= $PullCount; %i++) {
			$Pull[%i] = mFloor(getRandom() * $DuckSpawnCount);
			// check for duplicate start positions and change if necessary
			for(%j = %i - 1;%j > 0;%j--) {
				if ($Pull[%i] == $Pull[%j])	{
					$Pull[%i] = mFloor(getRandom() * $DuckSpawnCount);
					%j = %i;
				}
			}
		}
	}

	function scoreEnd() {
		%client = $Player.player.getOwnerClient();
		%accuracy = (%client.hits / %client.shots) * 100;
		$PassKills = $KillMin[$pref::trainingDifficulty ] <= %client.kills ? 1:0; 
		if($PassKills)
			%msg = "Mission Passed!";
		else
			%msg = "Mission Failed";
		%msg2 = $dif @ "\nKills made/needed : " @ %client.kills @ " / " @ $KillMin[$pref::trainingDifficulty] @ "\n" @ %client.shots @ " shots fired, with " @ %client.hits @ " hits.\nAccuracy : " @ %accuracy @ "%\n\nHit OK to end the mission";
		messageBoxOk(%msg, %msg2, "forceFinish();");
	}

	function setUpDifficultySettings(%skill) {
		// lower zVelocity based on skill for lower arc for higher difficulty
		// also set number of kills to pass
		if(%skill == 1) {
			%Zadd = 12;
			$dif = "Easy - Novice Sniper";
			$TimeBetweenPulls = 8000; //8 seconds
		}		
		if(%skill == 2) {
			%Zadd = 8;
			$dif = "Medium - Marksman Sniper";
			$TimeBetweenPulls = 7000; //8 seconds
		}
		if(%skill == 3) {
			%Zadd = 4;
			$dif = "Hard - Expert Sniper";
			$TimeBetweenPulls = 6000; //8 seconds
		}
		for(%i=0;%i<$DuckSpawnCount;%i++) {
			%temp = $Duck[%i,1] + %Zadd;
			$Duck[%i,1] = " " @ %temp;
		}
	}

// MODIFIED ORIGINAL FUNCTIONS ----------------------------------------------------

	function toggleScoreScreen(%val) {
		if ( %val )
			//error("No Score Screen in training.......");
			messageClient($player, 0, $player.miscMsg[noScoreScreen]);
	}

	function trainingComplete() {
		%skill = $pref::trainingDifficulty;
		switch (%skill) {
			case 2:
				%msg = "trainingOverMed";
			case 3:
				%msg = "trainingOverHard";
			default:
				%msg = "trainingOverEasy";
		}
		missionComplete( $player.miscMsg[%msg] );
	}

	function MP3Audio::play(%this) {
		// get out of my code damnit :P
	}

	function ClientCmdSetHudMode(%mode, %type, %node) {
		parent::ClientCmdSetHudMode(%mode, %type, %node);
		//TrainingMap.push();
	}

	function missionClientKilled() {
		//no console spam
	}
	function getTeammateGlobals(){
		//no console spam
	}

	function FlipFlop::objectiveInit(%data, %flipflop) {
		//SPAM PREVENTERS UNITE! KILL ALL AUTO-SPAM SCRIPTMAKERS!
	}

	function FlipFlop::playerTouch(%data, %flipFlop, %player) {	
		Parent::playerTouch(%data, %flipFlop, %player);
		if(!game.SwitchHit) {
			game.SwitchHit = true;
			centerPrintAll("Targets will start in 10 seconds. \nThe platform in front of the tower is a good spot to stand..",5,2);
			schedule(10000,0,"Pull");
		}
	}

	function SniperRifleImage::onFire(%data,%obj,%slot) {
		%client = %obj.getOwnerClient();
		if(!%client.isAIControlled()) {
			%client.shots += 1;
		}
   		if(!%obj.hasEnergyPack) {
      	      serverPlay3D(SniperRifleDryFireSound, %obj.getTransform());
      		return;
   		}
   		%pct = %obj.getEnergyLevel() / %obj.getDataBlock().maxEnergy;
   		$Energy = %pct;
		%p = new (%data.projectileType)() {
      		dataBlock        = %data.projectile;
      		initialDirection = %obj.getMuzzleVector(%slot);
      		initialPosition  = %obj.getMuzzlePoint(%slot);
      		sourceObject     = %obj;
      		damageFactor     = %pct * %pct;
      		sourceSlot       = %slot;
   		};
   		%p.setEnergyPercentage(%pct);
   		%obj.lastProjectile = %p;
   		MissionCleanup.add(%p);
   		serverPlay3D(SniperRifleFireSound, %obj.getTransform());
   		// AI hook
   		if(%obj.client)
      	%obj.client.projectile = %p;
   		%obj.setEnergyLevel(0);
	}

// Too large to format nicely... only changes between /////////////////////////////// lines
function Armor::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %momVec, %mineSC) {
//error("Armor::damageObject( "@%data@", "@%targetObject@", "@%sourceObject@", "@%position@", "@%amount@", "@%damageType@", "@%momVec@" )");
   	if(%targetObject.invincible || %targetObject.getState() $= "Dead")
      return;

	// if targetObject is in flyers and not scriptkilled
   if (%targetObject.isMounted() && %targetObject.scriptKilled $= "")
   {
      %mount = %targetObject.getObjectMount();
      if(%mount.team == %targetObject.team)
      {
         %found = -1;
         for (%i = 0; %i < %mount.getDataBlock().numMountPoints; %i++)
         {
            if (%mount.getMountNodeObject(%i) == %targetObject)
            {
               %found = %i;
               break;
            }
         }

         if (%found != -1)
         {
            if (%mount.getDataBlock().isProtectedMountPoint[%found])
            {
               %mount.getDataBlock().damageObject(%mount, %sourceObject, %position, %amount, %damageType);
               return;
            }
         }
      }
   }

   %targetClient = %targetObject.getOwnerClient();
   if(isObject(%mineSC))
      %sourceClient = %mineSC;   
   else
      %sourceClient = isObject(%sourceObject) ? %sourceObject.getOwnerClient() : 0;

   %targetTeam = %targetClient.team;

   //if the source object is a player object, player's don't have sensor groups
   // if it's a turret, get the sensor group of the target
   // if its a vehicle (of any type) use the sensor group
   if (%sourceClient)
      %sourceTeam = %sourceClient.getSensorGroup();
   else if(%damageType == $DamageType::Suicide)
      %sourceTeam = 0;
   else if(isObject(%sourceObject) && %sourceObject.getClassName() $= "Turret")
      %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
   else if( isObject(%sourceObject) &&
   	( %sourceObject.getClassName() $= "FlyingVehicle" || %sourceObject.getClassName() $= "WheeledVehicle" || %sourceObject.getClassName() $= "HoverVehicle"))
      %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
   else
   {
      if (isObject(%sourceObject) && %sourceObject.getTarget() >= 0 )
      {
         %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
      }
      else
      {
         %sourceTeam = -1;
      }
   }

   // if teamdamage is off, and both parties are on the same team
   // (but are not the same person), apply no damage
   if(!$teamDamage && (%targetClient != %sourceClient) && (%targetTeam == %sourceTeam))
      return;

   if(%targetObject.isShielded && %damageType != $DamageType::Blaster)
      %amount = %data.checkShields(%targetObject, %position, %amount, %damageType);

   if(%amount == 0)
      return;
///////////////////////////////////////////////////////////////////////////
	%damLoc = %targetObject.getDamageLocation(%position);
	%damLoc = firstWord(%damLoc);
   	// Set the damage flash
  	%damageScale = %data.damageScale[%damageType];
   	if(%damageScale !$= "")
      	%amount *= %damageScale;
	// if hit in torso or head and with a full energy shot - kill by hack
	if(%damageType == 6) {
		if($Energy == 1 && (%damLoc $= "torso" || %damLoc $= "head")) {
			%amount = %amount * 10;
   			%sourceClient.kills += 1;
		}
		%sourceClient.hits += 1;
	}
   	%flash = %targetObject.getDamageFlash() + (%amount * 2);
   	if (%flash > 0.75 && !%targetClient.isAIControlled()) // added && part
      	%flash = 0.75;
///////////////////////////////////////////////////////////////////////////   
   %previousDamage = %targetObject.getDamagePercent();
   %targetObject.setDamageFlash(%flash);
   %targetObject.applyDamage(%amount);
   Game.onClientDamaged(%targetClient, %sourceClient, %damageType, %sourceObject);

   %targetClient.lastDamagedBy = %damagingClient;
   %targetClient.lastDamaged = getSimTime();
   
   //now call the "onKilled" function if the client was... you know...  
   if(%targetObject.getState() $= "Dead")
   {
      // where did this guy get it?
      %damLoc = %targetObject.getDamageLocation(%position);
	      
      // should this guy be blown apart?
      if( %damageType == $DamageType::Explosion || 
          %damageType == $DamageType::TankMortar ||
          %damageType == $DamageType::Mortar ||
          %damageType == $DamageType::MortarTurret ||
          %damageType == $DamageType::BomberBombs ||
          %damageType == $DamageType::SatchelCharge ||
          %damageType == $DamageType::Missile )     
      {
         if( %previousDamage >= 0.35 ) // only if <= 35 percent damage remaining
         {
            %targetObject.setMomentumVector(%momVec);
            %targetObject.blowup(); 
         }
      }
   
      // this should be funny...
      if( %damageType == $DamageType::VehicleSpawn )
      {   
         %targetObject.setMomentumVector("0 0 1");
         %targetObject.blowup();
      }
      
      // If we were killed, max out the flash
      %targetObject.setDamageFlash(0.75);
      
      %damLoc = %targetObject.getDamageLocation(%position);
      Game.onClientKilled(%targetClient, %sourceClient, %damageType, %sourceObject, %damLoc);
   }
   else if ( %amount > 0.1 )
   {   
      if( %targetObject.station $= "" && %targetObject.isCloaked() )
      {
         %targetObject.setCloaked( false );
         %targetObject.reCloak = %targetObject.schedule( 500, "setCloaked", true ); 
      }
      
      playPain( %targetObject );
   }
}
	
};

//Duck package functions end=======================================================
